// Form1.cpp

#include "stdafx.h"

#include "Form1.h"
#include "TrafficLight.h"

using namespace TrafficLightDemo;

System::Void Form1::Form1_Load(System::Object^  sender, System::EventArgs^  e)
{
  Point ptNextLocation = Point::Empty;
  EventHandler ^ehTrafficLightClick = gcnew EventHandler(this, &Form1::TrafficLightClickHandler);
  for (int i = 1; i <= 4; ++i) {
    TrafficLight ^trl = gcnew TrafficLight;
    trl->Name = String::Format("Traffic light {0}", i);
    if (ptNextLocation.IsEmpty)
      ptNextLocation = Point(trl->Margin.Left, trl->Margin.Top);
    else
      ptNextLocation.Offset(trl->Margin.Left, 0);
    trl->Location = ptNextLocation;
    trl->Click += ehTrafficLightClick;
    Controls->Add(trl);
    cbxLight->Items->Add(trl->Name);
    ptNextLocation = Point(trl->Right + trl->Margin.Right, trl->Top);
  }
  cbxLight->SelectedIndex = 0;
}

System::Void Form1::cbxState_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
{
  safe_cast<TrafficLight ^>(Controls[cbxLight->Text])->State =
    static_cast<TrafficLightState>(Enum::Parse(TrafficLightState::typeid, cbxState->Text));
}

System::Void Form1::cbxLight_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
{
  cbxState->Text = safe_cast<TrafficLight ^>(Controls[cbxLight->Text])->State.ToString();
  chkCycle->Checked = m_setTrafficLightsToCycle->Contains(cbxLight->Text);
}

void Form1::TrafficLightClickHandler(Object ^sender, EventArgs ^e)
{
  cbxLight->Text = safe_cast<TrafficLight ^>(sender)->Name;
}

System::Void Form1::chkCycle_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
{
  if (chkCycle->Checked)
    m_setTrafficLightsToCycle->Add(cbxLight->Text);
  else
    m_setTrafficLightsToCycle->Remove(cbxLight->Text);
  cbxState->Enabled = !chkCycle->Checked;
}

System::Void Form1::tmrCycleState_Tick(System::Object^  sender, System::EventArgs^  e)
{
  for each (String ^strTrafficLight in m_setTrafficLightsToCycle) {
    TrafficLight ^trl = safe_cast<TrafficLight ^>(Controls[strTrafficLight]);
    trl->AdvanceCycle();
    if (trl->Name == cbxLight->Text)
      cbxState->Text = trl->State.ToString();
  }
}
